package data.scripts;

import com.fs.starfarer.api.BaseModPlugin;
import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.PluginPick;
import com.fs.starfarer.api.campaign.CampaignPlugin;
import com.fs.starfarer.api.combat.MissileAIPlugin;
import com.fs.starfarer.api.combat.MissileAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import data.scripts.ai.ParabolaAI;
//import data.scripts.world.CitadelGeduneGen;
import data.scripts.world.citadel.DefendersGen;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import org.dark.shaders.light.LightData;
import org.dark.shaders.util.TextureData;
import org.dark.shaders.util.ShaderLib;

public class CITModPlugin extends BaseModPlugin {

    private static void initCIT() {
            new DefendersGen().generate(Global.getSector());

        //boolean theresGed = true;

        /*try {
            Global.getSettings().getScriptClassLoader().loadClass("GeduneModPlugin");
        } catch (ClassNotFoundException ex2) {
            theresGed = false;
        }
        if (theresGed) {
            Global.getSector().addScript(new CitadelGeduneGen());
        }
        */
    }

    @Override
    public void onApplicationLoad() {
        try {
            Global.getSettings().getScriptClassLoader().loadClass("org.dark.shaders.util.ShaderLib");
        } catch (ClassNotFoundException ex) {
            return;
        }
        ShaderLib.init();
        LightData.readLightDataCSV("data/lights/citadel_light_data.csv");
        TextureData.readTextureDataCSV("data/lights/citadel_texture_data.csv");
    }
    

    @Override
    public void onNewGame() {
        
                try {  
            //Got Exerelin, so load Exerelin  
            Class<?> def = Global.getSettings().getScriptClassLoader().loadClass("exerelin.campaign.SectorManager");  
            Method method;  
            try {  
                method = def.getMethod("getCorvusMode");  
                Object result = method.invoke(def);  
                if ((boolean)result == true)  
                {  
                    // Exerelin running in Corvus mode, go ahead and generate our sector  
                    initCIT();  
                }  
            } catch (NoSuchMethodException | SecurityException | IllegalAccessException | IllegalArgumentException |  
                     InvocationTargetException ex) {  
                // check failed, do nothing  
            }  
              
        } catch (ClassNotFoundException ex) {  
            // Exerelin not found so continue and run normal generation code  
            initCIT(); 
        } 
    }
    
    

    public static final String PARABLOA_LRM_ID = "fox_ksupportmissile_proj";
    public static final String BLITZ_TORPEDO_ID = "fox_torp_missile";


    @Override
    public PluginPick<MissileAIPlugin> pickMissileAI(MissileAPI missile, ShipAPI launchingShip) {
        switch (missile.getProjectileSpecId()) {
            case PARABLOA_LRM_ID:
                return new PluginPick<MissileAIPlugin>(new ParabolaAI(missile, launchingShip), CampaignPlugin.PickPriority.MOD_SET);
            default:
        }
        switch (missile.getProjectileSpecId()) {
            case BLITZ_TORPEDO_ID   :
                return new PluginPick<MissileAIPlugin>(new ParabolaAI(missile, launchingShip), CampaignPlugin.PickPriority.MOD_SET);
            default:
        }
       return null;
    }
}
