package com.fs.starfarer.api.impl.campaign.econ;

import com.fs.starfarer.api.impl.campaign.ids.Commodities;

public class LightIndustrialComplex extends BaseMarketConditionPlugin {

	public void apply(String id) {
		
		float pop = getPopulation(market);
		
		market.getDemand(Commodities.ORGANICS).getDemand().modifyFlat(id, pop * ConditionData.LIGHT_INDUSTRY_ORGANICS_MULT);
		market.getDemand(Commodities.VOLATILES).getDemand().modifyFlat(id, pop * ConditionData.LIGHT_INDUSTRY_VOLATILES_MULT);
		market.getDemand(Commodities.HEAVY_MACHINERY).getDemand().modifyFlat(id, pop * ConditionData.LIGHT_INDUSTRY_MACHINERY_MULT);
		
		float productionMult = getProductionMult(market, Commodities.ORGANICS, Commodities.VOLATILES);
		
		market.getCommodityData(Commodities.DOMESTIC_GOODS).getSupply().modifyFlat(id, pop * ConditionData.LIGHT_INDUSTRY_DOMESTIC_GOODS_MULT * productionMult);
		market.getCommodityData(Commodities.LUXURY_GOODS).getSupply().modifyFlat(id, pop * ConditionData.LIGHT_INDUSTRY_LUXURY_GOODS_MULT * productionMult);
		//market.getCommodityData(Commodities.SUPPLIES).getSupply().modifyFlat(id, pop * ConditionData.LIGHT_INDUSTRY_SUPPLIES_MULT * f);
	}

	public void unapply(String id) {
		market.getDemand(Commodities.ORGANICS).getDemand().unmodify(id);
		market.getDemand(Commodities.VOLATILES).getDemand().unmodify(id);
		market.getDemand(Commodities.HEAVY_MACHINERY).getDemand().unmodify(id);
		
		market.getCommodityData(Commodities.DOMESTIC_GOODS).getSupply().unmodify(id);
		market.getCommodityData(Commodities.LUXURY_GOODS).getSupply().unmodify(id);
		//market.getCommodityData(Commodities.SUPPLIES).getSupply().unmodify(id);
	}

}
