package com.fs.starfarer.api.impl.campaign.econ;

import com.fs.starfarer.api.campaign.econ.MarketDemandAPI;

public class TradeCenter extends BaseMarketConditionPlugin {

	public void apply(String id) {
		float pop = getPopulation(market);
		float credits = pop * ConditionData.TRADE_CENTER_STOCKPILE_CREDITS_PER_DEMAND_PER_POP;
		for (MarketDemandAPI demand: market.getDemandData().getDemandList()) {
			float basePrice = demand.getBaseCommodity().getBasePrice();
			float baseUtility = demand.getBaseCommodity().getUtility();
			if (basePrice <= 0 || baseUtility <= 0) continue;
			float baseDemand = credits / basePrice * baseUtility;
			demand.getDemand().modifyFlat(id, baseDemand);
			demand.getNonConsumingDemand().modifyFlat(id, baseDemand);
		}
		
		market.getStability().modifyFlat(id, ConditionData.STABILITY_TRADE_CENTER, "Trade center");
	}

	public void unapply(String id) {
		for (MarketDemandAPI demand: market.getDemandData().getDemandList()) {
			demand.getDemand().unmodify(id);
			demand.getNonConsumingDemand().unmodify(id);
		}
		
		market.getStability().unmodify(id);
	}

}
