package com.fs.starfarer.api.impl.campaign.econ;

import com.fs.starfarer.api.impl.campaign.ids.Commodities;

public class VolatilesMiningComplex extends BaseMarketConditionPlugin {

	public void apply(String id) {
		market.getDemand(Commodities.REGULAR_CREW).getDemand().modifyFlat(id, ConditionData.VOLATILES_MINING_CREW);
		market.getDemand(Commodities.REGULAR_CREW).getNonConsumingDemand().modifyFlat(id, ConditionData.VOLATILES_MINING_CREW * ConditionData.CREW_MARINES_NON_CONSUMING_FRACTION);
		float crewDemandMet = market.getDemand(Commodities.REGULAR_CREW).getClampedAverageFractionMet();
		
		market.getCommodityData(Commodities.VOLATILES).getSupply().modifyFlat(id, ConditionData.VOLATILES_MINING_VOLATILES * crewDemandMet);
		market.getDemand(Commodities.HEAVY_MACHINERY).getDemand().modifyFlat(id, ConditionData.VOLATILES_MINING_MACHINERY);
	}

	public void unapply(String id) {
		market.getCommodityData(Commodities.VOLATILES).getSupply().unmodify(id);
		market.getDemand(Commodities.HEAVY_MACHINERY).getDemand().unmodify(id);
		
		market.getDemand(Commodities.REGULAR_CREW).getDemand().unmodify(id);
		market.getDemand(Commodities.REGULAR_CREW).getNonConsumingDemand().unmodify(id);
	}

}
