package com.fs.starfarer.api.ui;

import java.awt.Color;

import com.fs.starfarer.api.campaign.CampaignFleetAPI;
import com.fs.starfarer.api.combat.MutableStat;
import com.fs.starfarer.api.combat.StatBonus;
import com.fs.starfarer.api.fleet.FleetMemberAPI;



public interface TooltipMakerAPI {
	
	public interface FleetMemberValueGetter {
		boolean skipMember(FleetMemberAPI member);
		float getValue(FleetMemberAPI member);
		String getDisplayValue(FleetMemberAPI member);
		Color getValueColor(FleetMemberAPI member);
	}
	
	LabelAPI addTitle(String text);
	void setTitleFont(String titleFont);
	void setTitleSmallOrbitron();
	void setTitleFontColor(Color titleFontColor);
	
	void setParaFont(String paraFont);
	void setParaFontColor(Color paraFontColor);
	void setParaSmallInsignia();
	
	LabelAPI addPara(String format, float pad, Color hl, String... highlights);
	LabelAPI addPara(String str, float pad);
	LabelAPI addPara(String str, Color color, float pad);
	LabelAPI addSectionHeading(String str, Alignment align, float pad);
	LabelAPI addSectionHeading(String str, Color textColor, Color bgColor, Alignment align, float pad);
	
	void beginGrid(float itemWidth, int cols);
	void beginGrid(float itemWidth, int cols, Color labelColor);
	Object addToGrid(int x, int y, String label, String value);
	Object addToGrid(int x, int y, String label, String value, Color valueColor);
	void setGridLabelColor(Color nameColor);
	void addGrid(float pad);
	void beginGridFlipped(float itemWidth, int cols, float valueWidth, float valuePad);
	void beginGridFlipped(float itemWidth, int cols, Color labelColor, float valueWidth, float valuePad);
	void addStatModGrid(float width, float valueWidth, float valuePad, float pad, MutableStat stat);
	void addStatModGrid(float width, float valueWidth, float valuePad, float pad, StatBonus stat);
	void addStatGridForShips(float width, float valueWidth, float valuePad, float pad,
							 CampaignFleetAPI fleet, int maxNum, boolean ascending,
							 FleetMemberValueGetter getter);
}




