package data.missions.benchmark;

import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.campaign.CargoAPI;
import com.fs.starfarer.api.combat.BaseEveryFrameCombatPlugin;
import com.fs.starfarer.api.combat.CombatEngineAPI;
import com.fs.starfarer.api.combat.DamageType;
import com.fs.starfarer.api.combat.DeployedFleetMemberAPI;
import com.fs.starfarer.api.combat.FighterWingAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.fleet.FleetGoal;
import com.fs.starfarer.api.fleet.FleetMemberAPI;
import com.fs.starfarer.api.fleet.FleetMemberType;
import com.fs.starfarer.api.input.InputEventAPI;
import com.fs.starfarer.api.mission.FleetSide;
import com.fs.starfarer.api.mission.MissionDefinitionAPI;
import com.fs.starfarer.api.mission.MissionDefinitionPlugin;
import java.awt.Color;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Set;
import org.apache.log4j.Level;
import org.apache.log4j.Logger;
import org.lwjgl.util.vector.Vector2f;

public class MissionDefinition implements MissionDefinitionPlugin {

    public static final Logger log = Global.getLogger(MissionDefinition.class);

    private final List<String> ships = new ArrayList<>(188);

    @Override
    public void defineMission(MissionDefinitionAPI api) {
        // BRDY
        addShip("brdy_asura_assault");
        addShip("brdy_cetonia_standard");
        addShip("brdy_convergence_frontier");
        addShip("brdy_eschaton_armed");
        addShip("brdy_imaginos_elite");
        addShip("brdy_karkinos_assault");
        addShip("brdy_kurmaraja_elite");
        addShip("brdy_locust_cs");
        addShip("brdy_mantis_attack");
        addShip("brdy_megaceras_runner");
        addShip("brdy_morpheus_proto");
        addShip("brdy_nevermore_00_retro");
        addShip("brdy_revenant_anticap");
        addShip("brdy_robberfly_barrage");
        addShip("brdy_scorpion_adv");
        addShip("brdy_silverfish_b_standard");
        addShip("brdy_silverfish_mod_standard");
        addShip("brdy_silverfish_standard");
        addShip("brdy_stenos_exploration");
        addShip("brdy_typheus_defender");
        addShip("desdinova_assault");
        addShip("gonodactylus_assault");
        addShip("nevermore_advanced");
        addShip("scarab_attack");
        addShip("brdy_krait_wing");
        addShip("brdy_dipteron_wing");
        addShip("brdy_vespa_wing");
        addShip("brdy_serket_wing");
        // Citadel
        addShip("Fox_Battlecruiser_standard");
        addShip("Fox_Battleship_standard");
        addShip("Fox_Carrier_closesupport");
        addShip("Fox_catamaran_standard");
        addShip("Fox_Corvette_standard");
        addShip("Fox_Cruiser_standard");
        addShip("fox_dfrigate_standard");
        addShip("Fox_Dreadnaught_standard");
        addShip("Fox_Drone_standard");
        addShip("Fox_Frigate_standard");
        addShip("Fox_Hauler_standard");
        addShip("Fox_LDestroyer_standard");
        addShip("Fox_MDestroyer_standard");
        addShip("Fox_Minelayer_standard");
        addShip("Fox_Seige_assault");
        addShip("Fox_Tank_standard");
        addShip("fox_heak_medium");
        addShip("fox_mako_heavy");
        addShip("fox_arrowhead_light");
        addShip("fox_firewall_standard");
        addShip("fox_bomber_torp_variant");
        addShip("fox_bomber_plasma_variant");
        // Exigency
        addShip("exigency_carrier_Standard");
        addShip("exigency_compactfrigate_Attack");
        addShip("exigency_cruiser_Assault");
        addShip("exigency_destroyer_Balanced");
        addShip("exigency_indra_Standard");
        addShip("exigency_lightcarrier_Standard");
        addShip("exigency_yria_Anti-ship");
        addShip("exipirated_azryel_Assault");
        addShip("exipirated_gehenna_Standard");
        addShip("exipirated_harinder_Assault");
        addShip("exipirated_kafziel_Standard");
        addShip("exipirated_rauwel_Assault");
        addShip("exigency_naithyr_wing");
        addShip("exigency_azata_wing");
        addShip("exigency_naxos_wing");
        addShip("exigency_tarujan_wing");
        addShip("exigency_kaivor_a_wing");
        addShip("exigency_kaivor_wing");
        addShip("exigency_kaivor_cs_wing");
        addShip("exigency_glynado_wing");
        addShip("exipirated_azazel_wing");
        addShip("exipirated_saraph_wing");
        // II
        addShip("ii_auriga_arm");
        addShip("ii_basileus_ass");
        addShip("ii_basileus_f_arm");
        addShip("ii_caesar_bal");
        addShip("ii_centurion_art");
        addShip("ii_dominus_art");
        addShip("ii_jupiter_art");
        addShip("ii_leviathan_arm");
        addShip("ii_maximus_arm");
        addShip("ii_princeps_art");
        addShip("ii_sebastos_art");
        addShip("ii_decurion_art");
        addShip("ii_decurion_d_pirates_sta");
        addShip("ii_decurion_d_sta");
        addShip("ii_dictator_art");
        addShip("ii_dictator_d_sta");
        addShip("ii_eagle_i_ass");
        addShip("ii_falcon_i_art");
        addShip("ii_hammerhead_i_bul");
        addShip("ii_interrex_ass");
        addShip("ii_interrex_d_pirates_sta");
        addShip("ii_interrex_d_sta");
        addShip("ii_invictus_arm");
        addShip("ii_invictus_d_sta");
        addShip("ii_olympus_a_sta");
        addShip("ii_olympus_t_sta");
        addShip("ii_praetorian_art");
        addShip("ii_praetorian_d_sta");
        addShip("ii_wolf_i_art");
        addShip("ii_flamen_wing");
        addShip("ii_draconarius_wing");
        addShip("ii_vicarius_b_wing");
        addShip("ii_vicarius_a_wing");
        addShip("ii_vicarius_s_wing");
        addShip("ii_scutum_wing");
        // JP
        addShip("junk_pirates_boxenstein_blue_Support");
        addShip("junk_pirates_boxenstein_Slugger");
        addShip("junk_pirates_boxer_Fighter");
        addShip("junk_pirates_clam_Standard");
        addShip("junk_pirates_dugong_Standard");
        addShip("junk_pirates_goat_Standard");
        addShip("junk_pirates_hammer_Assault");
        addShip("junk_pirates_kraken_Standard");
        addShip("junk_pirates_langoustine_Standard");
        addShip("junk_pirates_magpie_Assault");
        addShip("junk_pirates_octopus_Standard");
        addShip("junk_pirates_orca_Assault");
        addShip("junk_pirates_scythe_Assault");
        addShip("junk_pirates_sickle_Pointdefense");
        addShip("junk_pirates_stoatA_Standard");
        addShip("junk_pirates_stoatB_Standard");
        addShip("junk_pirates_the_reaper_Standard");
        addShip("junk_pirates_turbot_Assault");
        addShip("pack_bedlington_canebianco_Standard");
        addShip("pack_bedlington_Standard");
        addShip("pack_BRT_Guard");
        addShip("pack_BRT_rothund_Guard");
        addShip("pack_komondor_canebianco_Standard");
        addShip("pack_komondor_rothund_Support");
        addShip("pack_komondor_Standard");
        addShip("pack_mastiff_Assault");
        addShip("pack_pitbull_canebianco_Standard");
        addShip("pack_pitbull_rothund_Standard");
        addShip("pack_pitbull_Standard");
        addShip("pack_ridgeback_Standard");
        addShip("pack_ridgeback_x_rothund_Standard");
        addShip("pack_ridgeback_x_Standard");
        addShip("pack_samoyed_caomarelo_Standard");
        addShip("pack_samoyed_decoupled_caomarelo_Standard");
        addShip("pack_samoyed_decoupled_Standard");
        addShip("pack_samoyed_Standard");
        addShip("pack_schnauzer_caomarelo_PD");
        addShip("pack_schnauzer_PD");
        addShip("pack_schnauzer_rothund_Standard");
        addShip("pack_sharpei_Assault");
        addShip("pack_wirefox_Assault");
        addShip("pack_wirefox_caomarelo_Standard");
        addShip("syndicate_asp_copperhead_Standard");
        addShip("syndicate_asp_diamondback_Standard");
        addShip("syndicate_asp_gigantophis_Standard");
        addShip("junk_pirates_shard_wing");
        addShip("junk_pirates_cleat_wing");
        addShip("junk_pirates_spike_wing");
        addShip("junk_pirates_splinter_wing");
        addShip("syndicate_asp_constrictor_wing");
        addShip("syndicate_asp_venom_wing");
        addShip("syndicate_asp_bite_wing");
        // Mayorate
        addShip("ilk_cimeterre_strike");
        addShip("ilk_del_azarchel_artillery");
        addShip("ilk_foraker_escort");
        addShip("ilk_jamaran_support");
        addShip("ilk_lilith_assault");
        addShip("ilk_ravana_pursuit");
        addShip("ilk_safir_converted_support");
        addShip("ilk_safir_standard");
        addShip("ilk_tiamat_assault");
        addShip("ilk_inanna_wing");
        addShip("ilk_raad_wing");
        addShip("ilk_angha_wing");
        // SCY
        addShip("SCY_alecto_beamer");
        addShip("SCY_argus_recon");
        addShip("SCY_balius_recon");
        addShip("SCY_baliusT_recon");
        addShip("SCY_centaur_standard");
        addShip("SCY_centaurT_standard");
        addShip("SCY_erymanthianBoar_brawler");
        addShip("SCY_erymanthianBoarArmored_brawler");
        addShip("SCY_euryale_recon");
        addShip("SCY_hydra_recon");
        addShip("SCY_keto_combat");
        addShip("SCY_khalkotauroi_balanced");
        addShip("SCY_lamia_beamer");
        addShip("SCY_lamiaArmored_beamer");
        addShip("SCY_lamiaPrototype_standard");
        addShip("SCY_lealaps_combat");
        addShip("SCY_manticore_combat");
        addShip("SCY_manticoreCarrier_recon");
        addShip("SCY_manticoreMirv_combat");
        addShip("SCY_manticorePhase_combat");
        addShip("SCY_medusa_recon");
        addShip("SCY_megaera_combat");
        addShip("SCY_nemeanLion_beamer");
        addShip("SCY_nemeanLion_prototype");
        addShip("SCY_orthrus_combat");
        addShip("SCY_siren_combat");
        addShip("SCY_stheno_antiFrigate");
        addShip("SCY_sthenoArmored_antiFrigate");
        addShip("SCY_stymphalian_combat");
        addShip("SCY_talos_combat");
        addShip("SCY_tisiphone_beamer");
        addShip("SCY_xanthus_standard");
        addShip("SCY_lowEndFighter_PD");
        addShip("SCY_lowEndFighter_interceptor");
        addShip("SCY_lowEndFighter_combat");
        addShip("SCY_highEndFighter_PD");
        addShip("SCY_highEndFighter_interceptor");
        addShip("SCY_highEndFighter_combat");
        addShip("SCY_bomber_torpedo");
        // SRA
        addShip("ms_ashnan_Fast");
        addShip("ms_charybdis_Attack");
        addShip("ms_elysium_Assault");
        addShip("ms_elysiumCiv_PD");
        addShip("ms_enlil_AF");
        addShip("ms_enlilCiv_Balanced");
        addShip("ms_inanna_Assault");
        addShip("ms_lambent_Standard");
        addShip("ms_mimir_Assault");
        addShip("ms_morningstar_AF");
        addShip("ms_morningstarCiv_PD");
        addShip("ms_potnia_Standard");
        addShip("ms_sargasso_Assault");
        addShip("ms_sargassoCiv_EMP");
        addShip("ms_scylla_Assault");
        addShip("ms_seski_Attack");
        addShip("ms_seskiCiv_BR");
        addShip("ms_shamash_Attack");
        addShip("ms_solidarity_Fast");
        addShip("ms_tartarus_AF");
        addShip("msp_potniaBis_AS");
        addShip("msp_southpaw_Assault");
        addShip("msp_thresher_Assault");
        addShip("ms_skinwalker_wing");
        addShip("ms_neriad_wing");
        addShip("ms_raksasha_wing");
        addShip("ms_kobold_wing");
        // SS+
        addShip("ssp_alastor_ass");
        addShip("ssp_alastor_d_sta");
        addShip("buffalo_luddic_path_stai");
        addShip("hound_luddic_path_assp");
        addShip("ssp_sunder_u_ass");
        addShip("ssp_vindicator_ass");
        addShip("ssp_vindicator_o_sta");
        addShip("ssp_albatross_art");
        addShip("ssp_arachne_ass");
        addShip("ssp_archer_assi");
        addShip("ssp_archon_ass");
        addShip("ssp_avalon_cor");
        addShip("ssp_barbarian_assp");
        addShip("ssp_beholder_ass");
        addShip("ssp_boar_arm");
        addShip("ssp_bull_arm");
        addShip("ssp_camel_ass");
        addShip("ssp_castle_arm");
        addShip("ssp_cathedral_aaa");
        addShip("ssp_circe_ass");
        addShip("ssp_cronus_art");
        addShip("ssp_dragon_bra");
        addShip("ssp_excelsior_ass");
        addShip("ssp_hecate_att");
        addShip("ssp_infernalmachine_art");
        addShip("ssp_kestrel_ass");
        addShip("ssp_locomotive_sta");
        addShip("ssp_nautilus_eli");
        addShip("ssp_phalanx_ass");
        addShip("ssp_punisher_ass");
        addShip("ssp_renegade_arm");
        addShip("ssp_revenant_assi");
        addShip("ssp_rook_log");
        addShip("ssp_scythe_bal");
        addShip("ssp_shark_arm");
        addShip("ssp_sidecar_ass");
        addShip("ssp_sloop_cor");
        addShip("ssp_stalker_bla");
        addShip("ssp_summit_cor");
        addShip("ssp_tick_arm");
        addShip("ssp_tiger_att");
        addShip("ssp_torch_arm");
        addShip("ssp_tundra_arm");
        addShip("ssp_vanguard_arm");
        addShip("ssp_venom_ass");
        addShip("ssp_venomx_eli");
        addShip("ssp_victory_art");
        addShip("ssp_vista_cor");
        addShip("ssp_vulture_assi");
        addShip("ssp_zenith_assi");
        addShip("ssp_sentinel_wing");
        addShip("ssp_claw_wing");
        addShip("ssp_claymore_wing");
        addShip("ssp_halberd_wing");
        // Templars
        addShip("tem_archbishop_ati");
        addShip("tem_crusader_agi");
        addShip("tem_jesuit_ati");
        addShip("tem_martyr_def");
        addShip("tem_paladin_agi");
        addShip("tem_teuton_fighter_wing");
        addShip("tem_teuton_assault_wing");
        addShip("tem_teuton_support_wing");
        addShip("tem_teuton_bomber_wing");
        // Bosses
        addShip("ii_boss_olympus_cus");
        addShip("ii_boss_praetorian_cus");
        addShip("ms_boss_charybdis_cus");
        addShip("ms_boss_mimir_cus");
        addShip("msp_boss_potniaBis_cus");
        addShip("junk_pirates_boss_dugong_cus");
        addShip("ssp_boss_aurora_cus");
        addShip("ssp_boss_falcon_cus");
        addShip("ssp_boss_hammerhead_cus");
        addShip("ssp_boss_hyperion_cus");
        addShip("ssp_boss_medusa_cus");
        addShip("ssp_boss_mule_cus");
        addShip("ssp_boss_odyssey_cus");
        addShip("ssp_boss_paragon_cus");
        addShip("ssp_boss_phaeton_cus");
        addShip("ssp_boss_sunder_cus");
        addShip("ssp_boss_tarsus_cus");
        addShip("syndicate_asp_boss_copperhead_cus");
        addShip("tem_boss_paladin_cus");
        // Starsector
        addShip("buffalo_d_Standard");
        addShip("buffalo_hegemony_Standard");
        addShip("buffalo_luddic_church_Standard");
        addShip("buffalo_pirates_Standard");
        addShip("buffalo_Standard");
        addShip("buffalo_tritachyon_Standard");
        addShip("cerberus_d_pirates_Standard");
        addShip("cerberus_d_Standard");
        addShip("cerberus_Standard");
        addShip("dominator_Assault");
        addShip("dominator_d_Assault");
        addShip("eagle_Assault");
        addShip("eagle_d_Assault");
        addShip("enforcer_Assault");
        addShip("enforcer_d_pirates_Strike");
        addShip("enforcer_d_Strike");
        addShip("falcon_Attack");
        addShip("falcon_d_CS");
        addShip("hammerhead_Balanced");
        addShip("hammerhead_d_CS");
        addShip("hermes_d_Standard");
        addShip("hermes_Standard");
        addShip("hound_d_pirates_Standard");
        addShip("hound_d_Standard");
        addShip("hound_hegemony_Standard");
        addShip("hound_luddic_church_Standard");
        addShip("hound_Standard");
        addShip("lasher_Assault");
        addShip("lasher_d_CS");
        addShip("mercury_Attack");
        addShip("mercury_d_Standard");
        addShip("mule_d_pirates_Smuggler");
        addShip("mule_d_Standard");
        addShip("mule_Standard");
        addShip("sunder_Assault");
        addShip("sunder_d_Assault");
        addShip("wolf_Assault");
        addShip("wolf_d_Attack");
        addShip("wolf_d_pirates_Attack");
        addShip("wolf_hegemony_Assault");
        addShip("afflictor_Strike");
        addShip("apogee_Balanced");
        addShip("astral_Elite");
        addShip("atlas_Standard");
        addShip("aurora_Balanced");
        addShip("brawler_Assault");
        addShip("buffalo2_FS");
        addShip("condor_FS");
        addShip("conquest_Elite");
        addShip("crig_Standard");
        addShip("doom_Strike");
        addShip("dram_Light");
        addShip("gemini_Standard");
        addShip("heron_Standard");
        addShip("hyperion_Attack");
        addShip("medusa_Attack");
        addShip("monitor_Escort");
        addShip("odyssey_Balanced");
        addShip("omen_PD");
        addShip("onslaught_Elite");
        addShip("ox_Standard");
        addShip("paragon_Elite");
        addShip("phaeton_Standard");
        addShip("prometheus_Super");
        addShip("shade_Assault");
        addShip("shepherd_Frontier");
        addShip("tempest_Attack");
        addShip("valkyrie_Elite");
        addShip("vigilance_Standard");
        addShip("broadsword_wing");
        addShip("xyphos_wing");
        addShip("gladius_wing");
        addShip("warthog_wing");
        addShip("thunder_wing");
        addShip("talon_wing");
        addShip("wasp_wing");
        addShip("dagger_wing");
        addShip("piranha_wing");
        addShip("trident_wing");
        addShip("longbow_wing");
        addShip("mining_drone_wing");

        api.initFleet(FleetSide.PLAYER, "Green", FleetGoal.ATTACK, true, 20);
        api.initFleet(FleetSide.ENEMY, "Red", FleetGoal.ATTACK, true, 20);

        api.setFleetTagline(FleetSide.PLAYER, "Green fleet");
        api.setFleetTagline(FleetSide.ENEMY, "Red fleet");

        api.addBriefingItem("This mission automatically enables dev mode");

        generateFleet(FleetSide.PLAYER, ships, api);
        generateFleet(FleetSide.ENEMY, ships, api);

        float width = 4000f;
        float height = 4000f;
        api.initMap(-width / 2f, width / 2f, -height / 2f, height / 2f);

        float minX = -width / 2;
        float minY = -height / 2;

        api.addNebula(minX + width * 0.25f, minY + height * 0.25f, 150f);
        api.addNebula(minX + width * 0.75f, minY + height * 0.25f, 150f);
        api.addNebula(minX + width * 0.75f, minY + height * 0.75f, 150f);
        api.addNebula(minX + width * 0.25f, minY + height * 0.75f, 150f);
        api.addNebula(minX + width * 0.5f, minY + height * 0.5f, 150f);

        api.addAsteroidField(minX + width * 0.5f, minY + height * 0.5f, 45f, 500f + height / 2f, 50f, 100f, 50);

        api.addObjective(minX + width * 0.25f, minY + height * 0.25f, "comm_relay");
        api.addObjective(minX + width * 0.75f, minY + height * 0.25f, "comm_relay");
        api.addObjective(minX + width * 0.75f, minY + height * 0.75f, "comm_relay");
        api.addObjective(minX + width * 0.25f, minY + height * 0.75f, "comm_relay");
        api.addObjective(minX + width * 0.5f, minY + height * 0.5f, "comm_relay");

        api.addPlugin(new Plugin());
    }

    private void addShip(String variant) {
        ships.add(variant);
    }

    private void generateFleet(FleetSide side, List<String> ships, MissionDefinitionAPI api) {
        for (String ship : ships) {
            try {
                String id = ship;
                FleetMemberAPI member;
                if (id.endsWith("_wing")) {
                    member = api.addToFleet(side, id, FleetMemberType.FIGHTER_WING, false);
                } else {
                    member = api.addToFleet(side, id, FleetMemberType.SHIP, false);
                }
                member.setCrewXPLevel(CargoAPI.CrewXPLevel.REGULAR);
            } catch (Exception ex) {
            }
        }
    }

    public final static class Plugin extends BaseEveryFrameCombatPlugin {

        private double advanced = 0f;
        private double advancedShort = 0f;
        private float clearanceEnemy = 0f;
        private float clearancePlayer = 0f;
        private boolean clearanceRightEnemy = true;
        private boolean clearanceRightPlayer = false;
        private boolean ended;
        private long epoch;
        private long epochInfo;
        private long epochMicro;
        private long epochShort;
        private final List<Double> frameTimes = new LinkedList<>();
        private int frames = 0;
        private int framesShort = 0;
        private float height = 4000f;
        private int maxFP = 0;
        private double memsGB = 0.0;
        private double minimums = 0.0;
        private long score;
        private double variances = 0.0;
        private float width = 4000f;
        private final Set<FighterWingAPI> wings = new HashSet<>(100);

        @Override
        public void advance(float amount, List<InputEventAPI> events) {
            List<ShipAPI> ships = Global.getCombatEngine().getShips();
            wings.clear();
            int playerFP = 0;
            int enemyFP = 0;
            for (ShipAPI ship : ships) {
                if (ship.getLocation().x <= -8500f || ship.getLocation().x >= 8500f || ship.getLocation().y <= -8500f || ship.getLocation().y >= 8500f) {
                    Global.getCombatEngine().applyDamage(ship, ship.getLocation(), 10000f, DamageType.OTHER, 0f, true, false, ship);
                }
                if (ship.isFighter() && ship.getWing() != null) {
                    if (!wings.contains(ship.getWing())) {
                        wings.add(ship.getWing());
                        if (!ship.getWing().isDestroyed()) {
                            if (ship.getWing().getWingOwner() == 0) {
                                DeployedFleetMemberAPI deployed = Global.getCombatEngine().getFleetManager(0).getDeployedFleetMemberEvenIfDisabled(ship);
                                if (deployed != null) {
                                    playerFP += deployed.getMember().getFleetPointCost();
                                }
                            } else if (ship.getWing().getWingOwner() == 1) {
                                DeployedFleetMemberAPI deployed = Global.getCombatEngine().getFleetManager(1).getDeployedFleetMemberEvenIfDisabled(ship);
                                if (deployed != null) {
                                    enemyFP += deployed.getMember().getFleetPointCost();
                                }
                            }
                        }
                    }
                } else {
                    if (ship.isAlive()) {
                        if (ship.getOwner() == 0) {
                            DeployedFleetMemberAPI deployed = Global.getCombatEngine().getFleetManager(0).getDeployedFleetMemberEvenIfDisabled(ship);
                            if (deployed != null) {
                                playerFP += deployed.getMember().getFleetPointCost();
                            }
                        } else if (ship.getOwner() == 1) {
                            DeployedFleetMemberAPI deployed = Global.getCombatEngine().getFleetManager(1).getDeployedFleetMemberEvenIfDisabled(ship);
                            if (deployed != null) {
                                enemyFP += deployed.getMember().getFleetPointCost();
                            }
                        }
                    }
                }
            }
            int playerTotalFP = playerFP;
            int enemyTotalFP = enemyFP;
            for (FleetMemberAPI member : Global.getCombatEngine().getFleetManager(0).getReservesCopy()) {
                playerTotalFP += member.getFleetPointCost();
            }
            for (FleetMemberAPI member : Global.getCombatEngine().getFleetManager(1).getReservesCopy()) {
                enemyTotalFP += member.getFleetPointCost();
            }
            maxFP = Math.max(maxFP, Math.max(playerTotalFP, enemyTotalFP));
            while (playerFP < Global.getCombatEngine().getFleetManager(0).getMaxFleetPoints().getModifiedValue()) {
                if (Global.getCombatEngine().getFleetManager(0).getReservesCopy().isEmpty()) {
                    break;
                }
                FleetMemberAPI member = Global.getCombatEngine().getFleetManager(0).getReservesCopy().get(0);
                playerFP += member.getFleetPointCost();
                ShipAPI ship = Global.getCombatEngine().getFleetManager(0).spawnFleetMember(member, new Vector2f(clearancePlayer, -3000f), 90f, 1f);
                Global.getCombatEngine().getFleetManager(1).removeFromReserves(member);
                if (clearanceRightPlayer) {
                    clearancePlayer += ship.getCollisionRadius() * 3f;
                    if (clearancePlayer >= 2000f) {
                        clearancePlayer -= ship.getCollisionRadius() * 5f;
                        clearanceRightPlayer = false;
                    }
                } else {
                    clearancePlayer -= ship.getCollisionRadius() * 3f;
                    if (clearancePlayer <= -2000f) {
                        clearancePlayer += ship.getCollisionRadius() * 5f;
                        clearanceRightPlayer = true;
                    }
                }
            }
            while (enemyFP < Global.getCombatEngine().getFleetManager(1).getMaxFleetPoints().getModifiedValue()) {
                if (Global.getCombatEngine().getFleetManager(1).getReservesCopy().isEmpty()) {
                    break;
                }
                FleetMemberAPI member = Global.getCombatEngine().getFleetManager(1).getReservesCopy().get(
                               Global.getCombatEngine().getFleetManager(1).getReservesCopy().size() - 1);
                enemyFP += member.getFleetPointCost();
                ShipAPI ship = Global.getCombatEngine().getFleetManager(1).spawnFleetMember(member, new Vector2f(clearanceEnemy, 3000f), 270f, 1f);
                Global.getCombatEngine().getFleetManager(1).removeFromReserves(member);
                if (clearanceRightEnemy) {
                    clearanceEnemy += ship.getCollisionRadius() * 3f;
                    if (clearanceEnemy >= 2000f) {
                        clearanceEnemy -= ship.getCollisionRadius() * 5f;
                        clearanceRightEnemy = false;
                    }
                } else {
                    clearanceEnemy -= ship.getCollisionRadius() * 3f;
                    if (clearanceEnemy <= -2000f) {
                        clearanceEnemy += ship.getCollisionRadius() * 5f;
                        clearanceRightEnemy = true;
                    }
                }
            }

            if (Global.getCombatEngine().getFleetManager(FleetSide.ENEMY).isInFullRetreat() ||
                    Global.getCombatEngine().getFleetManager(FleetSide.PLAYER).isInFullRetreat() ||
                    Global.getCombatEngine().getFleetManager(0).getReservesCopy().isEmpty() ||
                    Global.getCombatEngine().getFleetManager(1).getReservesCopy().isEmpty()) {
                if (!ended) {
                    ended = true;
                    double intervalAvg = (System.currentTimeMillis() - epoch) / 1000.0;
                    double fpsAvg = frames / intervalAvg;
                    double minimumFPS = minimums / (intervalAvg / 10.0);
                    double variancesAvg = variances / (intervalAvg / 10.0);
                    double gameSpeed = advanced / intervalAvg;
                    double gameSpeedFactor = 1.0 + Math.min(minimumFPS / 30.0, 1.0);
                    double stabilityFactor = (minimumFPS / fpsAvg + (1.0 - variancesAvg / (1000.0 / fpsAvg)) + (gameSpeed * gameSpeedFactor)) /
                           (2.0 + gameSpeedFactor);
                    score = Math.round((fpsAvg * Math.sqrt(Math.pow(2.0, stabilityFactor) / 2.0)) * 100.0);
                    log.info(String.format("********************************"));
                    log.info(String.format("Benchmark Results (%.1f minute run):", (System.currentTimeMillis() - epoch) / 60000.0));
                    log.info(String.format("  Average FPS: %.1f", fpsAvg));
                    log.info(String.format("  Minimum FPS: %.1f", minimumFPS));
                    log.info(String.format("  Average Frame Variance: %.2fms", variancesAvg));
                    log.info(String.format("  Perceived Game Speed: %d%%", Math.round(gameSpeed * 100.0)));
                    log.info(String.format("  SectorMarks: %d", score));
                    log.info(String.format("********************************"));
                    Global.getSoundPlayer().playUISound("cr_playership_critical", 1f, 2f);
                }
                Global.getCombatEngine().addFloatingText(new Vector2f(0f, 0f),
                                                         String.format("SectorMarks: %d", score),
                                                         200f, Color.yellow, null, 1f, 0f);
                return;
            }

            if (Global.getCombatEngine().isPaused()) {
                epoch += System.currentTimeMillis() - epochMicro;
                epochShort += System.currentTimeMillis() - epochMicro;
                epochInfo += System.currentTimeMillis() - epochMicro;
                epochMicro = System.currentTimeMillis();
                return;
            }

            double frameTime = (System.currentTimeMillis() - epochMicro) / 1000.0;
            advanced += amount;
            advancedShort += amount;
            frameTimes.add(frameTime);
            epochMicro = System.currentTimeMillis();

            frames++;
            framesShort++;

            if (System.currentTimeMillis() - epochShort >= 1000) {
                double interval = (System.currentTimeMillis() - epochShort) / 1000.0;
                double fps = framesShort / interval;
                double progress = 1.0 - Math.min(playerTotalFP - Global.getCombatEngine().getFleetManager(0).getMaxFleetPoints().getModifiedValue(),
                                                 enemyTotalFP - Global.getCombatEngine().getFleetManager(1).getMaxFleetPoints().getModifiedValue()) /
                       (double) (maxFP - Math.max(Global.getCombatEngine().getFleetManager(0).getMaxFleetPoints().getModifiedValue(),
                                                  Global.getCombatEngine().getFleetManager(1).getMaxFleetPoints().getModifiedValue()));
                double intervalAvg = (System.currentTimeMillis() - epoch) / 1000.0;
                double fpsAvg = frames / intervalAvg;
                double usedMemGB = (Runtime.getRuntime().totalMemory() - Runtime.getRuntime().freeMemory()) / (1073741824.0);
                memsGB += usedMemGB;
                log.info(String.format("Benchmark [%s] - %.1f FPS - %.2fGB Memory Used", new SimpleDateFormat("HH.mm.ss").format(new Date()), fps, usedMemGB));
                Global.getCombatEngine().addFloatingText(new Vector2f(0f, 87.5f),
                                                         String.format("Progress: %d%%", (int) (progress * 100.0)),
                                                         75f, Color.yellow, null, 1f, 0f);
                Global.getCombatEngine().addFloatingText(new Vector2f(0f, 0f),
                                                         String.format("Average FPS: %.1f", fpsAvg),
                                                         100f, Color.yellow, null, 1f, 0f);
                if (progress > 0.0 && System.currentTimeMillis() - epoch >= 1000 * 60 * 2) {
                    double speed = progress / ((System.currentTimeMillis() - epoch) / 60000.0);
                    double eta = (1.0 - progress) / speed;
                    Global.getCombatEngine().addFloatingText(new Vector2f(0f, -75f),
                                                             String.format("Time Remaining: %d minutes", Math.round(eta)),
                                                             50f, Color.yellow, null, 1f, 0f);
                }

                epochShort = System.currentTimeMillis();
                framesShort = 0;

                for (ShipAPI ship : ships) {
                    if (!ship.isAlive()) {
                        Global.getCombatEngine().applyDamage(ship, ship.getLocation(), 0.025f * ship.getMaxHitpoints(), DamageType.HIGH_EXPLOSIVE, 0f, true,
                                                             false, ship);
                    }
                }
            }

            if (System.currentTimeMillis() - epochInfo >= 1000 * 10) {
                double mean = 0.0;
                for (double frame : frameTimes) {
                    mean += frame;
                }
                mean /= frameTimes.size();
                double variance = 0.0;
                for (double frame : frameTimes) {
                    variance += (frame - mean) * (frame - mean);
                }
                variance /= frameTimes.size();
                double stdevMs = Math.sqrt(variance) * 1000.0;
                variances += stdevMs;
                double min = Double.MAX_VALUE;
                for (double frame : frameTimes) {
                    min = Math.min(min, 1.0 / frame);
                }
                minimums += min;
                double intervalAvg = (System.currentTimeMillis() - epoch) / 1000.0;
                double fpsAvg = frames / intervalAvg;
                double minimumFPS = minimums / (intervalAvg / 10.0);
                double variancesAvg = variances / (intervalAvg / 10.0);
                double progress = 1.0 - Math.min(playerTotalFP - Global.getCombatEngine().getFleetManager(0).getMaxFleetPoints().getModifiedValue(),
                                                 enemyTotalFP - Global.getCombatEngine().getFleetManager(1).getMaxFleetPoints().getModifiedValue()) /
                       (double) (maxFP - Math.max(Global.getCombatEngine().getFleetManager(0).getMaxFleetPoints().getModifiedValue(),
                                                  Global.getCombatEngine().getFleetManager(1).getMaxFleetPoints().getModifiedValue()));
                double memoryAvg = memsGB / intervalAvg;
                double intervalInfo = (System.currentTimeMillis() - epochInfo) / 1000.0;
                double gameSpeed = advancedShort / intervalInfo;
                log.info(String.format("Benchmark Stats [%s] (Progress: %d%%):", new SimpleDateFormat("HH:mm:ss").format(new Date()), (int) (progress * 100.0)));
                log.info(String.format("  Average FPS: %.1f", fpsAvg));
                log.info(String.format("  Minimum FPS: %.1f", minimumFPS));
                log.info(String.format("  Frame Variance: %.2fms", stdevMs));
                log.info(String.format("  Average Frame Variance: %.2fms", variancesAvg));
                log.info(String.format("  Average Memory Used: %.2fGB", memoryAvg));
                log.info(String.format("  Game Speed: %.1f%%", gameSpeed * 100.0));

                frameTimes.clear();
                advancedShort = 0.0;
                epochInfo = System.currentTimeMillis();
            }
        }

        @Override
        public void init(CombatEngineAPI engine) {
            log.setLevel(Level.INFO);
            engine.getContext().setStandoffRange(8000f);
            engine.getContext().setInitialDeploymentBurnDuration(0.5f);
            engine.getContext().setNormalDeploymentBurnDuration(0.5f);
            float ratio = Global.getSettings().getScreenWidth() / Global.getSettings().getScreenHeight();
            if (ratio < 1f) {
                width *= ratio;
            } else {
                height /= ratio;
            }
            Global.getSettings().setDevMode(true);
            engine.getViewport().setExternalControl(true);
            engine.getViewport().set(-width / 2f, -height / 2f, width, height);
            epoch = System.currentTimeMillis();
            epochShort = System.currentTimeMillis();
            epochMicro = System.currentTimeMillis();
            epochInfo = System.currentTimeMillis();
        }
    }
}
