package data.missions.sectormark;

import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.campaign.CargoAPI;
import com.fs.starfarer.api.fleet.FleetGoal;
import com.fs.starfarer.api.fleet.FleetMemberAPI;
import com.fs.starfarer.api.fleet.FleetMemberType;
import com.fs.starfarer.api.mission.FleetSide;
import com.fs.starfarer.api.mission.MissionDefinitionAPI;
import com.fs.starfarer.api.mission.MissionDefinitionPlugin;
import data.missions.benchmark.MissionDefinition.Plugin;
import java.util.ArrayList;
import java.util.List;
import org.apache.log4j.Logger;

public class MissionDefinition implements MissionDefinitionPlugin {

    public static final Logger log = Global.getLogger(MissionDefinition.class);

    private final List<String> ships = new ArrayList<>(188);

    @Override
    public void defineMission(MissionDefinitionAPI api) {
        addShip("ssp_tiger_str");
        addShip("wolf_Assault");
        addShip("ssp_tiger_str");
        addShip("wolf_Assault");
        addShip("ssp_claymore_wing");
        addShip("warthog_wing");
        addShip("ssp_boar_eli");
        addShip("sunder_Assault");
        addShip("ssp_tiger_str");
        addShip("wolf_Assault");
        addShip("ssp_tiger_str");
        addShip("wolf_Assault");
        addShip("ssp_claymore_wing");
        addShip("warthog_wing");
        addShip("ssp_boar_eli");
        addShip("sunder_Assault");
        addShip("ssp_stalker_sta");
        addShip("dominator_Outdated");
        addShip("ssp_tiger_str");
        addShip("wolf_Assault");
        addShip("ssp_tiger_str");
        addShip("wolf_Assault");
        addShip("ssp_claymore_wing");
        addShip("warthog_wing");
        addShip("ssp_boar_eli");
        addShip("sunder_Assault");
        addShip("ssp_tiger_str");
        addShip("wolf_Assault");
        addShip("ssp_tiger_str");
        addShip("wolf_Assault");
        addShip("ssp_claymore_wing");
        addShip("warthog_wing");
        addShip("ssp_boar_eli");
        addShip("sunder_Assault");
        addShip("ssp_stalker_sta");
        addShip("dominator_Outdated");
        addShip("ssp_victory_ass");
        addShip("onslaught_Standard");

        addShip("ssp_tiger_str");
        addShip("wolf_Assault");
        addShip("ssp_tiger_str");
        addShip("wolf_Assault");
        addShip("ssp_claymore_wing");
        addShip("warthog_wing");
        addShip("ssp_boar_eli");
        addShip("sunder_Assault");
        addShip("ssp_tiger_str");
        addShip("wolf_Assault");
        addShip("ssp_tiger_str");
        addShip("wolf_Assault");
        addShip("ssp_claymore_wing");
        addShip("warthog_wing");
        addShip("ssp_boar_eli");
        addShip("sunder_Assault");
        addShip("ssp_stalker_sta");
        addShip("dominator_Outdated");
        addShip("ssp_tiger_str");
        addShip("wolf_Assault");
        addShip("ssp_tiger_str");
        addShip("wolf_Assault");
        addShip("ssp_claymore_wing");
        addShip("warthog_wing");
        addShip("ssp_boar_eli");
        addShip("sunder_Assault");
        addShip("ssp_tiger_str");
        addShip("wolf_Assault");
        addShip("ssp_tiger_str");
        addShip("wolf_Assault");
        addShip("ssp_claymore_wing");
        addShip("warthog_wing");
        addShip("ssp_boar_eli");
        addShip("sunder_Assault");
        addShip("ssp_stalker_sta");
        addShip("dominator_Outdated");
        addShip("ssp_victory_ass");
        addShip("onslaught_Standard");

        addShip("ssp_tiger_str");
        addShip("wolf_Assault");
        addShip("ssp_tiger_str");
        addShip("wolf_Assault");
        addShip("ssp_claymore_wing");
        addShip("warthog_wing");
        addShip("ssp_boar_eli");
        addShip("sunder_Assault");
        addShip("ssp_tiger_str");
        addShip("wolf_Assault");
        addShip("ssp_tiger_str");
        addShip("wolf_Assault");
        addShip("ssp_claymore_wing");
        addShip("warthog_wing");
        addShip("ssp_boar_eli");
        addShip("sunder_Assault");
        addShip("ssp_stalker_sta");
        addShip("dominator_Outdated");
        addShip("ssp_tiger_str");
        addShip("wolf_Assault");
        addShip("ssp_tiger_str");
        addShip("wolf_Assault");
        addShip("ssp_claymore_wing");
        addShip("warthog_wing");
        addShip("ssp_boar_eli");
        addShip("sunder_Assault");
        addShip("ssp_tiger_str");
        addShip("wolf_Assault");
        addShip("ssp_tiger_str");
        addShip("wolf_Assault");
        addShip("ssp_claymore_wing");
        addShip("warthog_wing");
        addShip("ssp_boar_eli");
        addShip("sunder_Assault");
        addShip("ssp_stalker_sta");
        addShip("dominator_Outdated");
        addShip("ssp_victory_ass");
        addShip("onslaught_Standard");

        addShip("ssp_tiger_str");
        addShip("wolf_Assault");
        addShip("ssp_tiger_str");
        addShip("wolf_Assault");
        addShip("ssp_claymore_wing");
        addShip("warthog_wing");
        addShip("ssp_boar_eli");
        addShip("sunder_Assault");
        addShip("ssp_tiger_str");
        addShip("wolf_Assault");
        addShip("ssp_tiger_str");
        addShip("wolf_Assault");
        addShip("ssp_claymore_wing");
        addShip("warthog_wing");
        addShip("ssp_boar_eli");
        addShip("sunder_Assault");
        addShip("ssp_stalker_sta");
        addShip("dominator_Outdated");
        addShip("ssp_tiger_str");
        addShip("wolf_Assault");
        addShip("ssp_tiger_str");
        addShip("wolf_Assault");
        addShip("ssp_claymore_wing");
        addShip("warthog_wing");
        addShip("ssp_boar_eli");
        addShip("sunder_Assault");
        addShip("ssp_tiger_str");
        addShip("wolf_Assault");
        addShip("ssp_tiger_str");
        addShip("wolf_Assault");
        addShip("ssp_claymore_wing");
        addShip("warthog_wing");
        addShip("ssp_boar_eli");
        addShip("sunder_Assault");
        addShip("ssp_stalker_sta");
        addShip("dominator_Outdated");
        addShip("ssp_victory_ass");
        addShip("onslaught_Standard");

        api.initFleet(FleetSide.PLAYER, "Green", FleetGoal.ATTACK, true, 20);
        api.initFleet(FleetSide.ENEMY, "Red", FleetGoal.ATTACK, true, 20);

        api.setFleetTagline(FleetSide.PLAYER, "Green fleet");
        api.setFleetTagline(FleetSide.ENEMY, "Red fleet");

        api.addBriefingItem("Use this mission for official benchmarks!");
        api.addBriefingItem("This mission automatically enables dev mode");

        generateFleet(FleetSide.PLAYER, ships, api);
        generateFleet(FleetSide.ENEMY, ships, api);

        float width = 4000f;
        float height = 4000f;
        api.initMap(-width / 2f, width / 2f, -height / 2f, height / 2f);

        float minX = -width / 2;
        float minY = -height / 2;

        api.addNebula(minX + width * 0.25f, minY + height * 0.25f, 150f);
        api.addNebula(minX + width * 0.75f, minY + height * 0.25f, 150f);
        api.addNebula(minX + width * 0.75f, minY + height * 0.75f, 150f);
        api.addNebula(minX + width * 0.25f, minY + height * 0.75f, 150f);
        api.addNebula(minX + width * 0.5f, minY + height * 0.5f, 150f);

        api.addAsteroidField(minX + width * 0.5f, minY + height * 0.5f, 45f, 500f + height / 2f, 50f, 100f, 50);

        api.addObjective(minX + width * 0.25f, minY + height * 0.25f, "comm_relay");
        api.addObjective(minX + width * 0.75f, minY + height * 0.25f, "comm_relay");
        api.addObjective(minX + width * 0.75f, minY + height * 0.75f, "comm_relay");
        api.addObjective(minX + width * 0.25f, minY + height * 0.75f, "comm_relay");
        api.addObjective(minX + width * 0.5f, minY + height * 0.5f, "comm_relay");

        api.addPlugin(new Plugin());
    }

    private void addShip(String variant) {
        ships.add(variant);
    }

    private void generateFleet(FleetSide side, List<String> ships, MissionDefinitionAPI api) {
        for (String ship : ships) {
            try {
                String id = ship;
                FleetMemberAPI member;
                if (id.endsWith("_wing")) {
                    member = api.addToFleet(side, id, FleetMemberType.FIGHTER_WING, false);
                } else {
                    member = api.addToFleet(side, id, FleetMemberType.SHIP, false);
                }
                member.setCrewXPLevel(CargoAPI.CrewXPLevel.REGULAR);
            } catch (Exception ex) {
            }
        }
    }
}
